/*                                                        -*- linux-c -*-
 *   _  _ ____ __ _ ___ ____ ____ __ _ _ _ _ | 
 * .  \/  |--| | \|  |  |--< [__] | \| | _X_ | s e c u r e  s y s t e m s
 *
 * .vt|ar5k - PCI/CardBus 802.11a WirelessLAN driver for Atheros AR5k chipsets
 *
 * $Id: vt_ar5211.c,v 1.3 2003/05/27 23:26:19 reyk Exp $
 *
 * Copyright (c) 2002, .vantronix | secure systems
 *                     and Reyk Floeter <reyk@vantronix.net> 
 *
 * This program is free software; you can redistribute it and/or modify
 * it under the terms of the GNU General Public License as published by
 * the Free Software Foundation; either version 2 of the License, or
 * (at your option) any later version.
 *
 * This program is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU General Public License for more details.
 *
 * You should have received a copy of the GNU General Public License
 * along with this program; if not, write to the Free Software
 * Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
 */

#include <vt_ar5kconfig.h>
#include <vt_ar5k.h>

int vt_ar5211_eeprom_read(vt_local_t *local, u32 offset, u16 *data)
{
	struct net_device *dev = (struct net_device*) local->dev;
	int timeout = 10000;   
	u32 status;

	VENTER();

	/** enable eeprom read access */
	VT_WLAN_OUT32(VT_WLAN_IN32(AR5211_EEPROM_COMD) | AR5211_EEPROM_COMD_RESET, AR5211_EEPROM_COMD);
	VT_WLAN_OUT32(VT_WLAN_IN32(AR5211_EEPROM_COMD) | AR5211_EEPROM_COMD_READ, AR5211_EEPROM_COMD);

	/** set address */
	VT_WLAN_OUT32((u8)offset-1, AR5211_EEPROM_ADDR);
	
	while(timeout > 0) {
		udelay(1);
		status = VT_WLAN_IN32(AR5211_EEPROM_STATUS);
		if(status & AR5211_EEPROM_STAT_RDDONE) {
			if(status & AR5211_EEPROM_STAT_RDERR) {
				VPRINT("eeprom read access failed!\n");
				return(1);
			}
			status = VT_WLAN_IN32(AR5211_EEPROM_DATA);
			*data = status & 0x0000ffff;
			return(0);
		}
		timeout--;
	}
	
	VPRINT("eeprom read timeout!\n");

	VEXIT();

	return(1);
}

/* TODO */
int vt_ar5211_init(vt_local_t *local)
{
	return(0);
}
